config/routes.rb
Rails.application.routes.draw do
  get "login" => "sessions#new"
  get "signup" => "users#new"
  get "logout" => "sessions#destroy"

  get 'finances', to: 'finances#index'

  resources :sessions
  resources :users
  resources :people
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
  get "home/index"  
  root to: "sessions#new"
end

app/models/person.rb
require 'securerandom'
require 'open-uri'

class Person < ApplicationRecord

  before_save :make_profile_picture

  validates_presence_of  :first_name, :last_name
  validate :url_profile_is_valid

  def url_profile_is_valid
    if self.url_profile && !self.url_profile.empty?
      unless self.url_profile =~ URI::regexp
        img_base_path = Rails.root.join("app/assets/images/person")
        unless File.file?( img_base_path + self.url_profile )
          errors.add(:url_profile, "must be a URI or existing file name")
        end
      end
    end
  end

  #  SECU (A10:2021-Server-Side Request Forgery) : 
  #    Cette Route permet d'injecter des URLs sans la moindre vérification
  #  NOTE : Il y a une deuxiémme faille, ici on écrit directement dans les asset public, 
  #         il faudrait passe par active-storage, mais le code serais moins lisible pour cet exercise.
  #         Je vous laisse jouer avec active-storage.
  def make_profile_picture
    if self.url_profile && !self.url_profile.empty?
      img_base_path = Rails.root.join("app/assets/images/person")
      unless File.file?( img_base_path + url_profile )
        img_name = "#{SecureRandom.uuid}.jpeg"
        File.open("#{img_base_path}/#{img_name}", 'wb') {|file| file.write(URI.open(url_profile).read) }
        self.url_profile = img_name
      end
    end
  end
end

app/controllers/people_controller.rb
require 'uri'
class PeopleController < ApplicationController
  before_action :set_person, only: %i[ show edit update destroy ]

  # GET /people or /people.json
  def index
    @people = Person.all
  end

  # GET /people/1 or /people/1.json
  def show
  end

  # GET /people/new
  def new
    @person = Person.new
  end

  # GET /people/1/edit
  def edit
  end

  # POST /people or /people.json
  def create
    @person = Person.new(person_params)

    respond_to do |format|
      if @person.save
        format.html { redirect_to person_url(@person), notice: "Person was successfully created." }
        format.json { render :show, status: :created, location: @person }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @person.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /people/1 or /people/1.json
  def update
    respond_to do |format|
      if @person.update(person_params)
        format.html { redirect_to person_url(@person), notice: "Person was successfully updated." }
        format.json { render :show, status: :ok, location: @person }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @person.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /people/1 or /people/1.json
  def destroy
    @person.destroy

    respond_to do |format|
      format.html { redirect_to people_url, notice: "Person was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_person
      # SECU (A03:2021-Injection) : 
      #   risque d'injection SQL
      @person = Person.where("id = '#{params[:id]}'").first
    end

    # Only allow a list of trusted parameters through.
    def person_params
      params.require(:person).permit(:first_name, :last_name, :age, :url_profile)
    end
end

app/helpers/people_helper.rb
module PeopleHelper
end

app/views/people/_form.html.erb
  <% if person.errors.any? %>
    <div class="alert alert-danger alert-dismissible fade show" role="alert">
      <i class="bi bi-check-circle me-1"></i>
      <b><%= pluralize(person.errors.count, "error") %> prohibited this person from being saved:</b>
        <ul>
          <% person.errors.each do |error| %>
            <li><%= error.full_message %></li>
          <% end %>
        </ul>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
    </div>
  <% end %>
<div class="card">
  <div class="card-body">

<%= form_with(model: person) do |form| %>
  <div class="row mb-3">
    <%= form.label :first_name, class: "col-sm-2 col-form-label" %>
    <div class="col-sm-10">
      <%= form.text_field :first_name, class: "form-control" %>
    </div>
  </div>

  <div class="row mb-3">
    <%= form.label :last_name, class: "col-sm-2 col-form-label" %>
    <div class="col-sm-10">
      <%= form.text_field :last_name, class: "form-control" %>
    </div>
  </div>

  <div class="row mb-3">
    <%= form.label :age, class: "col-sm-2 col-form-label" %>
    <div class="col-sm-10">
      <%= form.number_field :age, class: "form-control" %>
    </div>
  </div>

  <div class="row mb-3">
    <%= form.label :url_profile, class: "col-sm-2 col-form-label" %> 
    <div class="col-sm-10">
      <%= form.text_field :url_profile, class: "form-control" %>
      <span>Entry sample - only jpeg is supported : </span>
      <span>http://xsgames.co/randomusers/avatar.php?g=female</span>
    </div>
  </div>

  <div class="text-left">
    <%= form.submit class: "btn btn-primary" %>
  </div>

<% end %>

  </div>
</div>

app/views/people/_person.html.erb
<%# SECU (A03:2021-Injection) : cross-site-scripting%>
<%#    Attentio au sucre syntaxique d'ERB et de rails%>
<div class="row">
  <div class="col-lg-3 col-md-4 label">First name</div>
  <div class="col-lg-9 col-md-8"><%= person.first_name %></div>
</div>

<div class="row">
  <div class="col-lg-3 col-md-4 label">Last name</div>
  <div class="col-lg-9 col-md-8"><%= raw person.last_name %></div>
</div>

<div class="row">
  <div class="col-lg-3 col-md-4 label ">Age</div>
  <div class="col-lg-9 col-md-8"><%= person.age %></div>
</div>

app/views/people/edit.html.erb
<div class="pagetitle">
  <h1>Editing person</h1>
</div>

<%= render "form", person: @person %>

<div>
  <%= link_to "Show this person", @person, class: "btn btn-light" %> 
  <%= link_to "Back to people", people_path, class: "btn btn-light" %>
</div>

app/views/people/index.html.erb
<% if notice %>
  <div class="alert alert-success alert-dismissible fade show" role="alert">
    <i class="bi bi-check-circle me-1"></i>
    <%= notice %>
    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
  </div>
<% end %>

<div class="pagetitle">
  <h1>People</h1>
</div>

<section class="section">
  <div class="row">
      <% @people.each do |person| %>

      <div class="col-lg-6">
        <div class="card">
          <% unless person.url_profile.empty?%>
          <div class="row g-0">
            <div class="col-md-4">
              <%= image_tag( "person/#{person.url_profile}", class: "img-fluid rounded-start") %>
            </div>
            <div class="col-md-8">
          <%end%>
            <div class="card-body">
              <h5 class="card-title">Detail for <%= person.first_name %>  <%= person.last_name %> </h5>
              <%= render person %>
              <div class="pt-3">
                <%= link_to "Show this person", person, class: "btn btn-outline-info btn-sm  "%>
              </div>
            </div>
          <% unless person.url_profile.empty?%>
              </div>
          </div>
          <%end%>
        </div>
      </div>

      <% end %>
  </div>
</section>

<div>
  <%= link_to "New person", new_person_path, class: "btn btn-primary"  %>
</div>

app/views/people/new.html.erb
<div class="pagetitle">
  <h1>Create à new person</h1>
</div>

<%= render "form", person: @person %>

<div>
  <%= link_to "Back to people", people_path, class: "btn btn-light" %>
</div>

app/views/people/show.html.erb
<% if notice %>
  <div class="alert alert-success alert-dismissible fade show" role="alert">
    <i class="bi bi-check-circle me-1"></i>
    <%= notice %>
    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
  </div>
<% end %>
 
<div class="pagetitle">
  <h1>People Detail</h1>
</div>

<div class="card">
  <% unless @person.url_profile.empty?%>
  <div class="row g-0">
    <div class="col-md-4">
      <%= image_tag( "person/#{@person.url_profile}", class: "img-fluid rounded-start") %>
    </div>
    <div class="col-md-8">
  <%end%>

  <div class="card-body">
    <h5 class="card-title">Detail for <%= @person.first_name %>  <%= @person.last_name %> </h5>
      <%= render @person%>
    </div>
  </div>

  <% unless @person.url_profile.empty?%>
    </div>
  </div>
  <%end%>
  <div>
    <div class="btn-group">
      <%= button_to "Destroy this person", @person, class: "btn btn-outline-warning btn-sm btn-space", method: :delete %>
    </div>
    <%= link_to "Edit this person", edit_person_path(@person), class: "btn btn-outline-primary btn-sm" %>
    <%= link_to "Back to people", people_path, class: "btn btn-outline-info btn-sm" %>
  </div>
</div>